Subject: Re: [Cbor] 🔔 WGLC with request for reviews on cbor-file-magic-02

From: John Mattsson <[email-masked]>
Date: Sat, 31 Jul 2021 10:02:37 +0000

Hi,

I have reviewed the submitted version -02. I have not looked at GiHub. COSE will likely use this for C509 and will try to specify that use soon.

I think the draft is in a good state. My comments are mostly non-technical.

Cheers,
John

Major comments:

- "as is a file extension"
The draft does not say anything about how to chose a file extension. I think the needs to say something and give guidance. Are protocols supposed to use some generic ".cbor" or use there own like ".c509". Is it recommended to use several tags with the same extension, i.e., should .c509 be used for several different tags (chain, bag, CSR, CRL,...) or should each tag use its own file extension. In the later case it would be good if the file extension was registered together with tag number in IANA.

- I think it would help the reader to have an examples (CBOR diagnostic + CBOR encoding) already in Sections 3.1 and 3.2.
  Something like the example in appendix B: "55800(1330664270(h'424F52'))"
  Example CBOR protocol values and the resulting bytes in the file would be even better and would really help to make the draft easy to understand.

Minor comments:

- "MacOS"
The official spelling of the current version is "macOS"

- "classic MacOS..."
Earlier versions were "Mac OS", "Mac OS X", and "OS X".

- "such as when attempting to do forensics on a damaged system"
Is that important enough to motivate additional bytes for Iot devices?

- "ZIP files of XML files."
Also media and fonts etc.

- "artifacts"
Is artifacts the right word here?

- "A magic number is ideally a unique fingerprint, present in the first 4 or 8 bytes of the file"
  "that results in a deterministic first 8 to 12 bytes"
  You should explain why you did not chose the "ideal" solution, or change the text on what is ideal.

- Would be good with a sentence explaining that if the protocol is a CBOR sequence then 3.1 cannot be used.

- "for each tag number NNNN, the representation of content-format (RFC7252) NNNN-1668546560"
  I don't understand the ” NNNN-1668546560” notation. Should it be NNNN + 1668546560 ?

- "Subregistry"
RFC 8126 states that the term subregistry was unfortunatly used in the past. I think "CoAP Content-Formats" is a registry in the "Constrained RESTful Environments (CoRE) Parameters" group.

- "00000000  d9 d9 f8 da 4f 50 53 4e  43 42 4f 52         |....OPSNCBOR|"
I don’t understand where the zeroes come from? Seems like postfix instead of prefix.

OLD "Both OpenOffice or MSOffice files"
NEW "Both OpenOffice and MSOffice files"

OLD "QRcode"
NEW "QR code"

OLD "This new sequence of tags are"
NEW "This new sequence of tags is"

OLD "the the use of CBOR"
NEW "the use of CBOR"

OLD "private keys, certificate requests and S/MIME content."
NEW "private keys, certificate requests, and S/MIME content."
(IETF use the Oxford comma)

OLD "certificate requests"
NEW "certification requests" or "certificate signing request"